# © 2024 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models


class FinancialContractGuarantee(models.Model):
    _name = "financial.contract.guarantee"
    _inherit = [
        "mail.thread",
        "mail.activity.mixin",
    ]
    _inherits = {"financial.contract": "contract_id"}
    _description = "Financial contract guarantee"
    _check_company_auto = True
    _rec_names_search = [
        "name",
        "number",
        "partner_id.name",
        "partner_id.member_number",
    ]
    _order = "create_date desc"

    external_loan_id = fields.Many2one(
        comodel_name="financial.contract",
        string="Prêt lié",
        domain="[('partner_id', '=', partner_id), ('type', '=', 'loan'), "
        "('deal_type', '=', 'external')]",
        financial_tool_type="guarantee",
    )
    guarantee_rate = fields.Float("Quotité garantie", tracking=1)
    is_counter_guarantee = fields.Boolean("Contre Garantie", default=False)
    bdf_scoring = fields.Char("Cotations BDF")
    loan_balance = fields.Monetary("Solde créance")
    guarantee_balance = fields.Monetary("Solde Garantie")
    fmg_amount = fields.Monetary("Montant FMG")
    social_share_amount = fields.Monetary("Montant parts sociales")
    final_risk_guarantee = fields.Monetary("Garantie risque final", tracking=1)

    # ------------------------------------------------------
    # Constrains functions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD (Override ORM)
    # ------------------------------------------------------
