# © 2024 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import fields, models


class FinancialProductTemplateGuarantee(models.Model):
    _name = "financial.product.template.guarantee"
    _inherit = [
        "mail.thread",
        "mail.activity.mixin",
    ]
    _inherits = {"financial.product.template": "product_id"}
    _description = "Financial product template guarantee"

    tool = fields.Selection(
        selection_add=[
            ("financial.contract.guarantee", "Garantie"),
        ],
        ondelete={"financial.contract.guarantee": "cascade"},
    )
    product_id = fields.Many2one(
        comodel_name="financial.product.template",
        string="Produit",
        required=True,
        index=True,
        ondelete="cascade",
    )
    # ------------------------------------------------------
    # Constrains functions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Computed fields / Search Fields
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Actions
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Override ORM
    # ------------------------------------------------------

    # ------------------------------------------------------
    # CRUD (Override ORM)
    # ------------------------------------------------------

    # ------------------------------------------------------
    # Business functions
    # ------------------------------------------------------
